---
title: Ajax
slug: Web/Guide/AJAX
tags:
  - AJAX
  - DOM
  - JSON
  - JavaScript
  - References
  - XMLHttpRequest
---
<div class="callout-box"><strong><a href="/en-US/docs/Web/Guide/AJAX/Getting_Started">Getting Started</a></strong><br>
An introduction to Ajax.</div>

<div>
<p><span class="seoSummary"><strong><u>A</u>synchronous <u>J</u>avaScript <u>a</u>nd <u>X</u>ML</strong>, while not a technology in itself, is a term coined in 2005 by Jesse James Garrett, that describes a "new" approach to using a number of existing technologies together</span>, including <a href="/en-US/docs/Web/HTML">HTML</a> or <a href="/en-US/docs/Glossary/XHTML">XHTML</a>, <a href="/en-US/docs/Web/CSS">CSS</a>, <a href="/en-US/docs/Web/JavaScript">JavaScript</a>, <a href="/en-US/docs/Web/API/Document_Object_Model">DOM</a>, <a href="/en-US/docs/Web/XML">XML</a>, <a href="/en-US/docs/Web/XSLT">XSLT</a>, and most importantly the {{domxref("XMLHttpRequest")}} object.<br>
 When these technologies are combined in the Ajax model, web applications are able to make quick, incremental updates to the user interface without reloading the entire browser page. This makes the application faster and more responsive to user actions.</p>

<p>Although X in Ajax stands for XML, {{glossary("JSON")}} is used more than XML nowadays because of its many advantages such as being lighter and a part of JavaScript. Both JSON and XML are used for packaging information in the Ajax model.</p>
</div>

<div class="row topicpage-table">
<div class="section">
<h2 class="Documentation" id="Documentation">Documentation</h2>

<dl>
 <dt><a href="/en-US/docs/Web/Guide/AJAX/Getting_Started">Getting Started</a></dt>
 <dd>This article guides you through the Ajax basics and gives you two simple hands-on examples to get you started.</dd>
 <dt><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest">Using the <code>XMLHttpRequest</code> API</a></dt>
 <dd>The {{domxref("XMLHttpRequest")}} API is the core of Ajax. This article will explain how to use some Ajax techniques, like:
 <ul>
  <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest#Handling_responses">Analyzing and manipulating the response of the server</a></li>
  <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest#Monitoring_progress">Monitoring the progress of a request</a></li>
  <li><a href="/en-US/docs/Web/API/XMLHttpRequest/Using_XMLHttpRequest#Submitting_forms_and_uploading_files">Submitting forms and upload binary files</a> – in <em>pure</em> Ajax, or using {{domxref("FormData")}} objects</li>
  <li>Using Ajax within <a href="/en-US/docs/Web/API/Worker">Web workers</a></li>
 </ul>
 </dd>
 <dt><a href="/en-US/docs/Web/API/Fetch_API">Fetch API</a></dt>
 <dd>The Fetch API provides an interface for fetching resources. It will seem familiar to anyone who has used {{domxref("XMLHTTPRequest")}}, but this API provides a more powerful and flexible feature set.</dd>
 <dt><a href="/en-US/docs/Web/API/Server-sent_events">Server-sent events</a></dt>
 <dd>Traditionally, a web page has to send a request to the server to receive new data; that is, the page requests data from the server. With server-sent events, it's possible for a server to send new data to a web page at any time, by pushing messages to the web page. These incoming messages can be treated as <em><a href="/en-US/docs/Web/API/Event">Events</a> + data</em> inside the web page. See also: <a href="/en-US/docs/Web/API/Server-sent_events/Using_server-sent_events">Using server-sent events</a>.</dd>
 <dt><a href="/en-US/docs/Web/API/History_API/Example"><em>Pure-Ajax</em> navigation example</a></dt>
 <dd>This article provides a working (minimalist) example of a <em>pure-Ajax</em> website composed only of three pages.</dd>
 <dt><a href="/en-US/docs/Web/API/XMLHttpRequest/Sending_and_Receiving_Binary_Data">Sending and Receiving Binary Data</a></dt>
 <dd>The <code>responseType</code> property of the <code>XMLHttpRequest</code> object can be set to change the expected response type from the server. Possible values are the empty string (default), <code>arraybuffer</code>, <code>blob</code>, <code>document</code>, <code>json</code>, and <code>text</code>. The <code>response</code> property will contain the entity body according to <code>responseType</code>, as an <code>ArrayBuffer</code>, <code>Blob</code>, <code>Document</code>, <code>JSON</code>, or string. This article will show some Ajax I/O techniques.</dd>
 <dt><a href="/en-US/docs/Web/XML">XML</a></dt>
 <dd>The <strong>Extensible Markup Language (XML)</strong> is a W3C-recommended general-purpose markup language for creating special-purpose markup languages. It is a simplified subset of SGML, capable of describing many different kinds of data. Its primary purpose is to facilitate the sharing of data across different systems, particularly systems connected via the Internet.</dd>
 <dt><a href="/en-US/docs/Web/Guide/Parsing_and_serializing_XML">Parsing and serializing XML</a></dt>
 <dd>How to parse an XML document from a string, a file or via javascript and how to serialize XML documents to strings, Javascript Object trees (JXON) or files.</dd>
 <dt><a href="/en-US/docs/Web/XPath">XPath</a></dt>
 <dd>XPath stands for <strong>X</strong>ML <strong>Path</strong> Language, it uses a non-XML syntax that provides a flexible way of addressing (pointing to) different parts of an <a href="/en-US/docs/XML">XML</a> document. As well as this, it can also be used to test addressed nodes within a document to determine whether they match a pattern or not.</dd>
 <dt>{{domxref("FileReader")}} API</dt>
 <dd>The <code>FileReader</code> API lets web applications asynchronously read the contents of files (or raw data buffers) stored on the user's computer, using {{domxref("File")}} or {{domxref("Blob")}} objects to specify the file or data to read. File objects may be obtained from a {{domxref("FileList")}} object returned as a result of a user selecting files using the {{HTMLElement("input")}} element, from a drag and drop operation's {{domxref("DataTransfer")}} object, or from the <code>mozGetAsFile()</code> API on an {{domxref("HTMLCanvasElement")}}.</dd>
 <dt><a href="/en-US/docs/Web/API/XMLHttpRequest/HTML_in_XMLHttpRequest">HTML in XMLHttpRequest</a></dt>
 <dd>The <a class="external" href="https://xhr.spec.whatwg.org/">XMLHttpRequest</a> specification adds HTML parsing support to {{domxref("XMLHttpRequest")}}, which originally supported only XML parsing. This feature allows Web apps to obtain an HTML resource as a parsed DOM using <code>XMLHttpRequest</code>.</dd>
</dl>

<p><span class="alllinks"><a href="/en-US/docs/tag/AJAX">View All...</a></span></p>
</div>

<div class="section">
<h2 id="Tools">Tools</h2>

<dl>
 <dt><a href="https://github.com/axios/axios">axios</a></dt>
 <dd>{{jsxref("Promise")}} based {{glossary("HTTP")}} client, which uses <code>XMLHttpRequest</code> internally.</dd>
</dl>

<h2 class="Other" id="See_also">See also</h2>

<dl>
 <dt><a href="https://pdfs.semanticscholar.org/c440/ae765ff19ddd3deda24a92ac39cef9570f1e.pdf">Ajax: A New Approach to Web Applications</a></dt>
 <dd>Jesse James Garrett, of Adaptive Path, wrote this article in February 2005, introducing Ajax and its related concepts.</dd>
 <dt><a href="https://xhr.spec.whatwg.org/">XMLHttpRequest Specification</a></dt>
 <dd>WHATWG Living Standard</dd>
</dl>
</div>
</div>
